Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1093 (new defect)

Opened 15 years ago

Last modified 14 years ago

IBSS merging with neighbors not always working in ad-hoc mode

Reported by: tjalling.hattink@ti-wmc.nl Assigned to:
Priority: major Milestone: version 0.9.4
Component: madwifi: 802.11 stack Version: trunk
Keywords: ad-hoc beacon merge Cc:
Patch is attached: 1 Pending:

Description

When a node starts a new IBSS ad-hoc network it will use its own mac address as BSS address. When a second node joins in it will take over this BSS address (merging) when it receives a beacon of the first node because the TSF beacon stamp is higher than its own TSF. This all works fine so far. What doesn't work is when the first node in the above situation is turned off and on again. After it is turned on it will receive a beacon from the second node with a higher TSF value, but it ignores this beacon and doesn't merge because the BSS address of the ad-hoc node is the same as its own mac address (because it initially started the network). The TSF value of the node is not updated and cause beacon transmissions to fail.

I've attached a patch that should fix this problem. First it does not check if the BSS address of the beacon matches the mac address anymore. It still should merge when TSF value is higher. Second, a bug is fixed that retrieved the wrong beacon TSF value when the beacon is from a different neighbor but has the same BSS address as the mac address.

This patch is created on r1970. Please take a look at it and see if I've fixed this problem correctly.

Signed-off-by: Tjalling Hattink <tjalling.hattink@ti-wmc.nl> Twente Institute of Wireless and Mobile Communications

Attachments

ibss_neigbor_merge_fix.diff (1.7 kB) - added by tjalling.hattink@ti-wmc.nl on 01/16/07 16:02:43.
Fixes IBSS neighbor merges in ad-hoc mode.

Change History

01/16/07 16:02:43 changed by tjalling.hattink@ti-wmc.nl

  • attachment ibss_neigbor_merge_fix.diff added.

Fixes IBSS neighbor merges in ad-hoc mode.

01/16/07 16:16:25 changed by mrenzmann

  • milestone set to version 0.9.x - progressive release candidate phase.

Thanks for the patch. I suggest to schedule it for inclusion in v0.9.4.

03/18/07 01:14:39 changed by scottr

  • milestone changed from version 0.9.x - progressive release candidate phase to version 0.9.4.

Tagging for 0.9.4 milestone

03/27/07 06:29:50 changed by derek@indranet.co.nz

With the ibss_neighbor_merge_fix.diff patch, the forming of an adhoc network is a bit different.

prior to the patch, with three nodes (all on a preset/fixed ip with

iwconfig athX ap 02:04:08:10:20:30

I brought the nodes up, and all could see each other and ping each other just fine.

With the patch applied, two nodes formed an ibss, but the third could not join the network, Once I initiated a scan (iwlist athX scan) all nodes could see each other. In my network, bgscans have been turn off.

07/16/07 01:34:08 changed by benoit.papillault@free.fr

Should be fixed by the madwifi-ibss-merge-clean.diff patch attached to ticket 1033